// Scan I2C bus for device responses
/*
#define SDA_PORT PORTD
//#define SDA_PIN 3
#define SCL_PORT PORTD
#define SCL_PIN 5
*/
#define I2C_TIMEOUT 100
#define I2C_NOINTERRUPT 0
#define I2C_SLOWMODE 1
#define FAC 1
#define I2C_CPUFREQ (F_CPU/FAC)


// Corresponds to A4/A5 - the hardware I2C pins on Arduinos
#define SDA_PORT PORTC
#define SDA_PIN 4
#define SCL_PORT PORTC
#define SCL_PIN 5
#define I2C_FASTMODE 1

#include <SoftI2CMaster.h>
#include <avr/io.h>
#include <LiquidCrystal.h>


// 接続ピンをして指定してライブラリを初期化
//LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
LiquidCrystal lcd(5, 6, 7, 8, 9, 10, 11); //SD1602VBWB
//------------------------------------------------------------------------------
void CPUSlowDown(int fac) {
  // slow down processor by a fac
    CLKPR = _BV(CLKPCE);
    CLKPR = _BV(CLKPS1) | _BV(CLKPS0);
}
  
int x, y, z;
uint8_t dt[3];
char buf[18];

void setup(void) {
#if FAC != 1
  CPUSlowDown(FAC);
#endif

//  Serial.begin(115200); // change baudrate to 2400 on terminal when low CPU freq!
  lcd.begin(16, 2); 
  lcd.setCursor(0, 0);
  lcd.print("Robi Gyro Sensor");
  lcd.setCursor(0, 1);
  lcd.print("value display");
  delay(5000);  //ロビの起動を待たせる
  
  lcd.setCursor(0, 1);
  lcd.print("                ");
  x = y = z = 0;
}


void loop(void)
{
  uint8_t i2c_adr = 152;  //ジャイロ
  uint8_t reg_adr = 0;    //X軸

  for (reg_adr = 0; reg_adr < 3; reg_adr++)
  {
    if (i2c_start(i2c_adr|I2C_WRITE)) {              // スタートコンディションを発行する
          if (i2c_write(reg_adr)) {               // レジスタアドレスを指定
               if (i2c_rep_start(i2c_adr|I2C_READ)) { // リピート・スタートコンディションを発行する
                     dt[reg_adr] = (char)i2c_read(true) ;
            }
          }
     }
    i2c_stop() ;                                   // ストップコンディションを発行する
  }

  if (dt[1] != 0)
  {
    if (dt[0] < 33)
      x = dt[0];
    else if (dt[0] < 64)
      x = dt[0] - 64;

   if (dt[1] < 33)
      y = dt[1];
    else if (dt[1] < 64)
      y = dt[1] - 64;
      
   if (dt[2] < 33)
      z = dt[2];
    else if (dt[2] < 64)
      z = dt[2] - 64;
 
    sprintf(buf, "X=%d,Y=%d,Z=%d    ", x, y, z);
    lcd.setCursor(0, 0);
    lcd.print(buf);
  }
  delay(500);
}
