
#include <avr/pgmspace.h>
#include <LiquidCrystal.h>

// 接続ピンをして指定してライブラリを初期化
//LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
LiquidCrystal lcd(5, 6, 7, 8, 9, 10, 11); //SD1602VBWB

// Scan I2C bus for device responses
/*
#define SDA_PORT PORTD
//#define SDA_PIN 3
#define SCL_PORT PORTD
#define SCL_PIN 5
*/
#define I2C_TIMEOUT 100
#define I2C_NOINTERRUPT 0
#define I2C_SLOWMODE 1
#define FAC 1
#define I2C_CPUFREQ (F_CPU/FAC)


// Corresponds to A4/A5 - the hardware I2C pins on Arduinos
#define SDA_PORT PORTC
#define SDA_PIN 4
#define SCL_PORT PORTC
#define SCL_PIN 5
#define I2C_FASTMODE 1

#include <SoftI2CMaster.h>
#include <avr/io.h>

//------------------------------------------------------------------------------
void CPUSlowDown(int fac) {
  // slow down processor by a fac
    CLKPR = _BV(CLKPCE);
    CLKPR = _BV(CLKPS1) | _BV(CLKPS0);
}

const char id1[] PROGMEM = "\xd3\xbc\xd3\xbc";
const char id2[] PROGMEM = "\xc8\xaa\xc8\xaa\xb7\xb2\xc3";
const char id3[] PROGMEM = "\xc8\xb4\xdb\xcb\xde\xb8\xdd";
const char id4[] PROGMEM = "\xc8\xb4\xb7\xb2\xc3";
const char id5[] PROGMEM = "\xb7\xb2\xc3\xb7\xb2\xc3";
const char id6[] PROGMEM = "\xdb\xcb\xde\xb8\xdd";
const char id7[] PROGMEM = "\xdb\xcb\xde\xc1\xac\xdd";
const char id8[] PROGMEM = "\xdb\xce\xde\xb8\xdd";
const char id9[] PROGMEM = "\xdb\xce\xde\xaf\xc4\xb8\xdd";
const char id10[] PROGMEM = "\xdb\xce\xde\xc1\xac\xdd";

const char id11[] PROGMEM = "\xc5\xcf\xb4\xca?";
const char id12[] PROGMEM = "\xb5\xc5\xcf\xb4\xca?";
const char id13[] PROGMEM = "\xc5\xcf\xb4\xca\xc5\xc6?";
const char id14[] PROGMEM = "\xbc\xde\xba\xbc\xae\xb3\xb6\xb2\xbc\xc3";
const char id15[] PROGMEM = "\xc5\xc6\xb6\xde\xc3\xde\xb7\xd9\xc9";
const char id16[] PROGMEM = "\xc4\xb8\xb7\xde\xca?";
const char id17[] PROGMEM = "\xb5\xc4\xba\xc9\xba?";
const char id18[] PROGMEM = "\xc5\xdd\xbb\xb2\xc5\xc9?";
const char id19[] PROGMEM = "\xbc\xdd\xc1\xae\xb3\xca?";
const char id20[] PROGMEM = "\xc0\xb2\xbc\xde\xad\xb3\xca?";

const char id21[] PROGMEM = "\xc8\xc0\xde\xdd\xca?";
const char id22[] PROGMEM = "\xbc\xde\xad\xdd\xcb\xde\xca\xb2\xb2";
const char id23[] PROGMEM = "\xb1\xb2\xbb\xc2\xbc\xc3";
const char id24[] PROGMEM = "\xca\xbc\xde\xd2\xcf\xbc\xc3";
const char id25[] PROGMEM = "\xb5\xca\xd6\xb3";
const char id26[] PROGMEM = "\xba\xdd\xc6\xc1\xca";
const char id27[] PROGMEM = "\xba\xdd\xca\xde\xdd\xca";
const char id28[] PROGMEM = "\xb5\xd4\xbd\xd0";
const char id29[] PROGMEM = "\xb2\xaf\xc3\xb7\xcf\xbd";
const char id30[] PROGMEM = "\xb2\xaf\xc3\xb8\xd9\xc8";

const char id31[] PROGMEM = "\xcf\xc0\xde\xd4\xd9";
const char id32[] PROGMEM = "\xbc\xde\xac\xb1\xcf\xc0\xc8";
const char id33[] PROGMEM = "\xdb\xcb\xde\xb8\xdd\xcf\xc0\xc8";
const char id34[] PROGMEM = "\xcf\xc0\xba\xdd\xc4\xde\xc8";
const char id35[] PROGMEM = "\xbb\xd6\xb3\xc5\xd7";
const char id36[] PROGMEM = "\xca\xde\xb2\xca\xde\xb2";
const char id37[] PROGMEM = "\xc0\xc0\xde\xb2\xcf";
const char id38[] PROGMEM = "\xb6\xb4\xaf\xc0\xd6";
const char id39[] PROGMEM = "\xb9\xde\xdd\xb7?"; 
const char id40[] PROGMEM = "\xb5\xc2\xb6\xda\xbb\xcf";

const char id41[] PROGMEM = "\xba\xde\xb8\xdb\xb3\xbb\xcf";
const char id42[] PROGMEM = "\xc4\xde\xb3\xc0\xde\xaf\xc0?";
const char id43[] PROGMEM = "";
const char id44[] PROGMEM = "\xbd\xc0\xb0\xc4";
const char id45[] PROGMEM = "\xb6\xb2\xbc";
const char id46[] PROGMEM = "\xca\xbc\xde\xd2";
const char id47[] PROGMEM = "\xbd\xc4\xaf\xcc\xdf";
const char id48[] PROGMEM = "\xbc\xad\xb3\xd8\xae\xb3";
const char id49[] PROGMEM = "\xb5\xdc\xd8\xc6\xbc\xd6";
const char id50[] PROGMEM = "\xb5\xdc\xd8\xc6\xbd\xd9";

const char id51[] PROGMEM = "\xc4\xcf\xda";
const char id52[] PROGMEM = "\xc4\xcf\xaf\xc3";
const char id53[] PROGMEM = "\xd3\xb3\xb2\xb2\xd6";
const char id54[] PROGMEM = "\xb5\xbc\xcf\xb2";
const char id55[] PROGMEM = "\xc1\xae\xaf\xc4\xcf\xaf\xc3";
const char id56[] PROGMEM = "\xcf\xb4\xc6\xbd\xbd\xdd\xc3\xde";
const char id57[] PROGMEM = "\xb1\xd9\xb2\xc3\xb7\xc3";
const char id58[] PROGMEM = "\xcf\xb4\xc6\xb7\xc3";
const char id59[] PROGMEM = "\xba\xaf\xc1\xcd\xb5\xb2\xc3\xde";
const char id60[] PROGMEM = "\xba\xaf\xc1\xc6\xb5\xb2\xc3\xde";
 
const char id61[] PROGMEM = "\xba\xaf\xc1\xb7\xc3";
const char id62[] PROGMEM = "\xba\xaf\xc1\xc6\xb7\xc3";
const char id63[] PROGMEM = "\xc1\xb6\xb8\xc6\xb7\xc3";
const char id64[] PROGMEM = "\xba\xaf\xc1\xd1\xb2\xc3";
const char id65[] PROGMEM = "\xcb\xc0\xde\xd8\xc6\xb7\xc3";
const char id66[] PROGMEM = "\xcb\xc0\xde\xd8\xc6\xb2\xaf\xc3";
const char id67[] PROGMEM = "\xcb\xc0\xde\xd8\xd1\xb2\xc3";
const char id68[] PROGMEM = "\xd0\xb7\xde\xc6\xb7\xc3";
const char id69[] PROGMEM = "\xd0\xb7\xde\xc6\xb2\xaf\xc3";
const char id70[] PROGMEM = "\xd0\xb7\xde\xd1\xb2\xc3";

const char id71[] PROGMEM = "\xb5\xb7\xc3\xd6";
const char id72[] PROGMEM = "\xb5\xb7\xc3";
const char id73[] PROGMEM = "\xc0\xc1\xb1\xb6\xde\xaf\xc3";
const char id74[] PROGMEM = "\xc0\xaf\xc3";
const char id75[] PROGMEM = "\xbd\xdc\xaf\xc3";
const char id76[] PROGMEM = "\xbd\xdc\xaf\xc3\xc3";
const char id77[] PROGMEM = "\xc8\xba\xdb\xb6\xde\xaf\xc3";
const char id78[] PROGMEM = "\xc8\xba\xdb\xdd\xc3\xde";
const char id79[] PROGMEM = "\xb3\xbc\xdb\xbb\xb6\xde\xaf\xc3";
const char id80[] PROGMEM = "\xb3\xbc\xdb\xc6\xbb\xb6\xde\xaf\xc3";

const char id81[] PROGMEM = "\xbc\xad\xb0\xc4";
const char id82[] PROGMEM = "\xb9\xaf\xc3";
const char id83[] PROGMEM = "\xb3\xc1\xdc\xc3\xde\xb1\xb5\xb2\xc3\xde";
const char id84[] PROGMEM = "\xcc\xd8\xb6\xb9";
const char id85[] PROGMEM = "\xcc\xd8\xb6\xb9\xb6\xb9\xc3";
const char id86[] PROGMEM = "\xd0\xad\xb0\xbc\xde\xaf\xb8\xbd\xc0\xb0\xc4";
const char id87[] PROGMEM = "\xd6\xb6\xaf\xc0\xc8";
const char id88[] PROGMEM = "\xc0\xc9\xbc\xb2\xc8";
const char id89[] PROGMEM = "\xc0\xc9\xbc\xb6\xaf\xc0\xc8";
const char id90[] PROGMEM = "\xb3\xda\xbc\xb2\xc8";

const char id91[] PROGMEM = "\xb6\xbc\xba\xb2\xc8";
const char id92[] PROGMEM = "\xb6\xdc\xb2\xb2\xc8";
const char id93[] PROGMEM = "\xb5\xd3\xbc\xdb\xb2\xc8";
const char id94[] PROGMEM = "\xb5\xd3\xbc\xdb\xb6\xaf\xc0\xc8\xb4";
const char id95[] PROGMEM = "\xb6\xaf\xba\xb2\xb2\xc8";
const char id96[] PROGMEM = "\xba\xcf\xaf\xc0\xc8";
const char id97[] PROGMEM = "\xba\xcf\xaf\xc0\xd6";
const char id98[] PROGMEM = "\xb6\xc5\xbc\xb2\xc8";
const char id99[] PROGMEM = "\xc2\xd7\xb2\xc8";
const char id100[] PROGMEM = "\xc2\xd7\xb2\xd6";

const char id101[] PROGMEM = "\xb6\xc5\xbc\xb2\xd6";
const char id102[] PROGMEM = "\xc2\xb6\xda\xc0\xd6";
const char id103[] PROGMEM = "\xc2\xb6\xda\xc0\xc8";
const char id104[] PROGMEM = "\xc5\xb8\xde\xbb\xd2\xc3";
const char id105[] PROGMEM = "\xca\xb9\xde\xcf\xbc\xc3";
const char id106[] PROGMEM = "\xb9\xde\xdd\xb7\xc2\xde\xb9\xc3";
const char id107[] PROGMEM = "\xb2\xb2\xba\xc4\xb6\xde\xb1\xaf\xc0\xd6";
const char id108[] PROGMEM = "\xb2\xd4\xc5\xba\xc4\xb6\xde\xb1\xaf\xc0";
const char id109[] PROGMEM = "\xba\xde\xb3\xb6\xb8\xbc\xc0\xd6";
const char id110[] PROGMEM = "\xc0\xde\xd2\xc0\xde\xaf\xc0";

const char id111[] PROGMEM = "\xc0\xdd\xbc\xde\xae\xb3\xcb\xde\xc5\xdd\xc0\xde";
const char id112[] PROGMEM = "\xb7\xc8\xdd\xcb\xde\xc5\xdd\xc0\xde";
const char id113[] PROGMEM = "\xb8\xd8\xbd\xcf\xbd\xc0\xde\xd6";
const char id114[] PROGMEM = "\xc3\xbd\xc4\xc5\xdd\xc0\xde";
const char id115[] PROGMEM = "\xbc\xb1\xb2\xc5\xdd\xc0\xde";
const char id116[] PROGMEM = "\xc3\xde\xb0\xc4\xc5\xdd\xc0\xde";
const char id117[] PROGMEM = "\xd8\xae\xba\xb3\xb2\xb8\xdd\xc0\xde";
const char id118[] PROGMEM = "\xb6\xbe\xde\xcb\xb2\xc1\xac\xaf\xc0";
const char id119[] PROGMEM = "\xb9\xdd\xb6\xbc\xc0\xdd\xc0\xde";
const char id120[] PROGMEM = "\xc9\xd0\xbd\xb7\xde\xc1\xac\xaf\xc0";

const char id121[] PROGMEM = "\xb5\xb3\xb4\xdd\xbc\xc3";
const char id122[] PROGMEM = "\xb5\xbc\xae\xb3\xb6\xde\xc2\xc0\xde\xd6";
const char id123[] PROGMEM = "\xca\xda\xd9\xc8";
const char id124[] PROGMEM = "\xca\xda\xc3\xd9\xc8";
const char id125[] PROGMEM = "\xb1\xd2\xcc\xd9\xc8";
const char id126[] PROGMEM = "\xb1\xd2\xcc\xaf\xc3\xd9\xc8";
const char id127[] PROGMEM = "\xb7\xae\xb3\xb1\xc2\xb2\xc8";
const char id128[] PROGMEM = "\xb7\xae\xb3\xbb\xd1\xb2\xc8";
const char id129[] PROGMEM = "\xb2\xb2\xc3\xdd\xb7\xc0\xde\xc8";
const char id130[] PROGMEM = "\xc3\xda\xcb\xde\xc2\xb9\xc3";

const char id131[] PROGMEM = "\xc3\xda\xcb\xde\xd0\xc0\xb2";
const char id132[] PROGMEM = "\xc3\xda\xcb\xde\xd0\xd6\xb3\xb6";
const char id133[] PROGMEM = "\xc3\xda\xcb\xde\xb9\xbc\xc3";
const char id134[] PROGMEM = "\xc1\xac\xdd\xc8\xd9\xb6\xb4\xc3";
const char id135[] PROGMEM = "\xc1\xac\xdd\xc8\xd9\xb7\xd8\xb6\xb4";
const char id136[] PROGMEM = "\xb5\xc4\xb5\xb5\xb7\xb8\xbc\xc3";
const char id137[] PROGMEM = "\xb5\xdd\xd8\xae\xb3\xb5\xb5\xb7\xb8";
const char id138[] PROGMEM = "\xba\xb4\xb5\xb5\xb7\xb8\xbc\xc3";
const char id139[] PROGMEM = "\xb5\xc4\xc1\xb2\xbb\xb8\xbc\xc3";
const char id140[] PROGMEM = "\xb5\xdd\xd8\xae\xb3\xc1\xb2\xbb\xb8";
 
const char id141[] PROGMEM = "\xba\xb4\xc1\xb2\xbb\xb8\xbc\xc3";
const char id142[] PROGMEM = "\xc0\xde\xdd\xbd\xbc\xc3";
const char id143[] PROGMEM = "\xc0\xde\xdd\xbd\xbc\xd6\xb3\xd6";
const char id144[] PROGMEM = "\xb5\xc4\xde\xaf\xc3";
const char id145[] PROGMEM = "\xb2\xaf\xbc\xae\xc6\xb5\xc4\xde\xdb\xb3";
const char id146[] PROGMEM = "\xb5\xbf\xb3\xbc\xde\xbc\xc3";
const char id147[] PROGMEM = "\xb7\xda\xb2\xc6\xbc\xc3";
const char id148[] PROGMEM = "\xba\xba\xdb\xce\xde";
const char id149[] PROGMEM = "\xba\xba\xdb\xce\xde\xc6\xbf\xb3\xbc\xde\xbb\xbe\xc3";
const char id150[] PROGMEM = "\xc0\xb2\xcf\xb0";
 
const char id151[] PROGMEM = "\xb1\xd7\xb0\xd1";
const char id152[] PROGMEM = "\xd2\xbb\xde\xcf\xbc";
const char id153[] PROGMEM = "\xbc\xde\xb6\xdd\xca\xb6\xaf\xc3";
const char id154[] PROGMEM = "\xb2\xaf\xcc\xdf\xdd";
const char id155[] PROGMEM = "\xbb\xdd\xcc\xdf\xdd";
const char id156[] PROGMEM = "\xba\xde\xcc\xdd";
const char id157[] PROGMEM = "\xc5\xc5\xcc\xdd";
const char id158[] PROGMEM = "\xbc\xde\xad\xc2\xcc\xdf\xdd";
const char id159[] PROGMEM = "\xbc\xde\xad\xb3\xba\xde\xcc\xdd";
const char id160[] PROGMEM = "\xb1\xbf\xce\xde\xb3";
 
const char id161[] PROGMEM = "\xb1\xbf\xdd\xc3\xde";
const char id162[] PROGMEM = "\xb2\xaf\xbc\xae\xc6\xb1\xbf\xdd\xc3\xde";
const char id163[] PROGMEM = "\xb2\xaf\xbc\xae\xc6\xb1\xbf\xce\xde\xb3";
const char id164[] PROGMEM = "\xc5\xc6\xb6\xbc\xc3";
const char id165[] PROGMEM = "\xb5\xd3\xbc\xdb\xb2\xba\xc4\xb2\xaf\xc3";
const char id166[] PROGMEM = "\xb9\xde\xb0\xd1";
const char id167[] PROGMEM = "\xb9\xde\xb0\xd1\xbd\xd9";
const char id168[] PROGMEM = "\xb9\xde\xb0\xd1\xbc\xd6\xb3";
const char id169[] PROGMEM = "\xca\xde\xd7\xdd\xbd\xb9\xde\xb0\xd1";
const char id170[] PROGMEM = "\xb8\xb2\xbd\xde\xc0\xde\xbc\xc3";
 
const char id171[] PROGMEM = "\xb8\xb2\xbd\xde\xbd\xd9";
const char id172[] PROGMEM = "\xb8\xb2\xbd\xde";
const char id173[] PROGMEM = "\xd3\xc9\xcf\xc8";
const char id174[] PROGMEM = "\xd3\xc9\xcf\xc8\xbc\xc3";
const char id175[] PROGMEM = "\xb3\xc3\xde\xc0\xc3\xcc\xbe";
const char id176[] PROGMEM = "\xcc\xaf\xb7\xdd\xb3\xdd\xc4\xde\xb3";
const char id177[] PROGMEM = "\xb3\xc0\xb3\xc0\xaf\xc3";
const char id178[] PROGMEM = "\xbb\xaf\xb6\xb0\xbc\xd6\xb3";
const char id179[] PROGMEM = "\xbb\xaf\xb6\xb0\xbc\xc3";
const char id180[] PROGMEM = "\xca\xc0\xb1\xb9\xde";
 
const char id181[] PROGMEM = "\xca\xc0\xb1\xb9\xde\xb9\xde\xb0\xd1\xbc\xc3";
const char id182[] PROGMEM = "\xb3\xd7\xc5\xb2\xbc\xc3";
const char id183[] PROGMEM = "\xb3\xd7\xc5\xaf\xc3";
const char id184[] PROGMEM = "\xbc\xb0\xb4\xd1\xd4\xaf\xc3";
const char id185[] PROGMEM = "\xba\xcf\xb0\xbc\xac\xd9\xd4\xaf\xc3";
const char id186[] PROGMEM = "\xbc\xde\xac\xdd\xb9\xdd";
const char id187[] PROGMEM = "\xbc\xde\xac\xdd\xb9\xdd\xbc\xd6";
const char id188[] PROGMEM = "\xbe\xb7\xad\xd8\xc3\xa8\xd3\xb0\xc4\xde";
const char id189[] PROGMEM = "\xce\xde\xb3\xca\xdd\xd3\xb0\xc4\xde";
const char id190[] PROGMEM = "\xb5\xd9\xbd\xca\xde\xdd";

const char id191[] PROGMEM = "\xd9\xbd\xca\xde\xdd\xbc\xc3";
const char id192[] PROGMEM = "\xdb\xcb\xde\xb7\xb7\xb2\xaf\xca\xdf\xc2";
const char id193[] PROGMEM = "\xb7\xae\xb3\xc9\xb3\xdd\xbe\xb2\xca?";
const char id194[] PROGMEM = "\xb7\xae\xb3\xc9\xd7\xaf\xb7\xb0\xb6\xd7\xb0\xca?";
const char id195[] PROGMEM = "\xbc\xac\xbc\xdd\xc4\xd9\xd6";
const char id196[] PROGMEM = "\xca\xb2\xc1\xb0\xbd\xde";
const char id197[] PROGMEM = "\xca\xb2\xce\xdf\xb0\xbd\xde";
const char id198[] PROGMEM = "\xd2\xaf\xbe\xb0\xbc\xde\xd3\xb0\xc4\xde";
const char id199[] PROGMEM = "\xca\xde\xaf\xc3\xd8\xa8\xb0\xc0\xde\xb2\xbc\xde\xae\xb3\xcc\xde?";
const char id200[] PROGMEM = "\xc3\xde\xdd\xc1\xc0\xde\xb2\xbc\xde\xae\xb3\xcc\xde?";

const char id201[] PROGMEM = "\xbc\xde\xad\xb3\xc3\xde\xdd\xbd\xd9?";
const char id202[] PROGMEM = "\xbc\xde\xad\xb3\xc3\xde\xdd\xc0\xde\xb2\xbc\xde\xae\xb3\xcc\xde?";
const char id203[] PROGMEM = "\xbc\xde\xad\xb3\xc3\xde\xdd\xbc\xd6\xb3";
const char id204[] PROGMEM = "\xb5\xc5\xb6\xbd\xb2\xc0?";
const char id205[] PROGMEM = "\xb5\xc5\xb6\xbd\xb2\xc3\xc5\xb2?";
const char id206[] PROGMEM = "\xc8\xd1\xb8\xc5\xb2?";
const char id207[] PROGMEM = "\xc2\xb6\xda\xc3\xc5\xb2?";
const char id208[] PROGMEM = "\xd3\xb3\xc8\xd6\xb3";
const char id209[] PROGMEM = "\xc0\xb6\xca\xbc\xc4\xd3\xc0\xb6";
const char id210[] PROGMEM = "\xb4\xce\xde\xd9\xc0\xaf\xc3\xbc\xaf\xc3\xd9?";

const char id211[] PROGMEM = "\xb7\xdb\xce\xde\xaf\xc3\xbc\xaf\xc3\xd9?";
const char id212[] PROGMEM = "\xc3\xde\xb1\xba\xde\xbd\xc3\xa8\xb0\xc6";
const char id213[] PROGMEM = "\xdb\xce\xde\xbe\xde\xdb\xaf\xc3\xbc\xaf\xc3\xd9?";
const char id214[] PROGMEM = "\xc3\xde\xb1\xba\xde\xbd\xc3\xa8\xb0\xc6";
const char id215[] PROGMEM = "\xca\xb2";
const char id216[] PROGMEM = "\xb2\xb2\xb4";
const char id217[] PROGMEM = "\xbd\xb7\xc0\xde\xd6";
const char id218[] PROGMEM = "\xb7\xd7\xb2\xc0\xde\xd6";
const char id219[] PROGMEM = "\xc4\xde\xaf\xc1\xc3\xde\xd3\xc5\xb2";
const char id220[] PROGMEM = "\xb6\xaf\xc0";

const char id221[] PROGMEM = "\xcf\xb9\xc0";
const char id222[] PROGMEM = "\xb1\xb2\xba";
const char id223[] PROGMEM = "\xb2\xb2\xd6";
const char id224[] PROGMEM = "\xb5\xaf\xb9\xb0";
const char id225[] PROGMEM = "\xd8\xae\xb3\xb6\xb2";
const char id226[] PROGMEM = "\xdc\xb6\xaf\xc0";
const char id227[] PROGMEM = "\xc1\xb6\xde\xb3\xd6";
const char id228[] PROGMEM = "\xc5\xc6\xb6\xb2\xaf\xc0?";
const char id229[] PROGMEM = "\xc5\xdd\xc3\xb2\xaf\xc0?";
const char id230[] PROGMEM = "\xd3\xb3\xb2\xaf\xb6\xb2\xb2\xaf\xc3";

const char id231[] PROGMEM = "\xc5\xdd\xc3\xde\xd3\xc5\xb2";
const char id232[] PROGMEM = "\xb5\xd2\xc3\xde\xc4\xb3";
const char id233[] PROGMEM = "\xb1\xd8\xb6\xde\xc4\xb3";
const char id234[] PROGMEM = "\xba\xde\xd2\xdd\xc8";
const char id235[] PROGMEM = "\xc0\xbd\xb6\xaf\xc0\xd6";
const char id236[] PROGMEM = "\xb6\xde\xdd\xca\xde\xaf\xc0\xc8";
const char id237[] PROGMEM = "\xc0\xde\xb2\xbc\xde\xae\xcc\xde\xc0\xde\xd6";
const char id238[] PROGMEM = "\xc0\xde\xb2\xbc\xde\xae\xb3\xcc\xde";
const char id239[] PROGMEM = "\xca\xd4\xb8\xb6\xb4\xd9\xd6";
const char id240[] PROGMEM = "\xb5\xbf\xb8\xc5\xd9";
 
const char id241[] PROGMEM = "\xb5\xbf\xb8\xc5\xd9\xd6";
const char id242[] PROGMEM = "\xba\xde\xca\xdd";
const char id243[] PROGMEM = "\xba\xde\xca\xdd\xc0\xcd\xde\xd9";
const char id244[] PROGMEM = "\xba\xde\xca\xdd\xc6\xbd\xd9";
const char id245[] PROGMEM = "\xb5\xcc\xdb";
const char id246[] PROGMEM = "\xb5\xcc\xdb\xca\xb2\xd9";
const char id247[] PROGMEM = "\xbc\xde\xae\xb3\xbd\xde\xc0\xde\xc8";
const char id248[] PROGMEM = "\xc4\xd3\xc0\xde\xc1\xc6\xc5\xaf\xc3";
const char id249[] PROGMEM = "\xc4\xd3\xc0\xde\xc1\xc0\xde\xd6";
const char id250[] PROGMEM = "\xc0\xde\xb2\xbd\xb7";

const char id251[] PROGMEM = "\xc4\xd7\xdd\xcc\xab\xb0\xd1";
const char id252[] PROGMEM = "\xb5\xca\xd6\xb3\xbb\xdd";
const char id253[] PROGMEM = "\xba\xc4\xca\xde\xc9\xda\xdd\xbc\xad\xb3";
const char id254[] PROGMEM = "\xdc\xb6\xd9\xba\xc4\xca\xde\xb5\xbc\xb4\xc3";
const char id255[] PROGMEM = "\xc5\xdd\xc3\xde\xd4\xc8\xdd";
const char id256[] PROGMEM = "\xc1\xb6\xde\xb3\xc0\xde\xdb";
const char id257[] PROGMEM = "\xdb\xce\xde\xaf\xc4\xc9\xba\xc4\xb5\xbc\xb4\xc3";
const char id258[] PROGMEM = "\xb3\xcf\xb8\xb2\xaf\xc0\xd6";
const char id259[] PROGMEM = "\xbc\xaf\xca\xdf\xb2\xbc\xc1\xac\xaf\xc0";
const char id260[] PROGMEM = "\xc3\xde\xdd\xba\xde\xdd\xd3\xb0\xc4\xde";
 
const char id261[] PROGMEM = "\xd2\xaf\xbe\xb0\xbc\xde\xc2\xc0\xb4\xc3";
const char id262[] PROGMEM = "\xbd\xb7\xc5\xcb\xc4\xb6\xde\xc3\xde\xb7\xc0";
const char id263[] PROGMEM = "\xc0\xde\xb2\xb4\xaf\xc4\xbc\xc5\xb7\xac";
const char id264[] PROGMEM = "\xcc\xc4\xaf\xc1\xac\xc0";
const char id265[] PROGMEM = "\xc0\xcd\xde\xbd\xb7\xde\xc1\xac\xaf\xc0";
const char id266[] PROGMEM = "\xba\xdd\xb9\xde\xc2\xcb\xdf\xdd\xc1";
const char id267[] PROGMEM = "\xbd\xba\xde\xb6\xaf\xc0\xc8";
const char id268[] PROGMEM = "\xbd\xba\xde\xb8\xbc\xde\xae\xb3\xbd\xde\xc0\xde\xc8";
const char id269[] PROGMEM = "\xb2\xaf\xca\xdf\xb2\xc2\xb7\xb1\xaf\xc3\xd6";
const char id270[] PROGMEM = "\xb2\xaf\xbc\xae\xc6\xc9\xd3\xb3\xd6";
 
const char id271[] PROGMEM = "\xdc\xc0\xbc\xc9\xba\xc4\xbd\xb7?";
const char id272[] PROGMEM = "\xdc\xc0\xbc\xc9\xba\xc4\xc4\xde\xb3\xb5\xd3\xb3?";
const char id273[] PROGMEM = "\xb2\xaf\xca\xdf\xb2\xc2\xb7\xb1\xaf\xc3\xd6";
const char id274[] PROGMEM = "\xb2\xaf\xbc\xae\xc6\xc9\xd3\xb3\xd6";
const char id275[] PROGMEM = "\xbd\xb2\xaf\xc1\xb5\xdd";
const char id276[] PROGMEM = "\xbd\xb2\xaf\xc1\xb5\xcc";

uint_farptr_t ninshiki[] = {
  id1,id2,id3,id4,id5,id6,id7,id8,id9,id10,  
  id11,id12,id13,id14,id15,id16,id17,id18,id19,id20,
  id21,id22,id23,id24,id25,id26,id27,id28,id29,id30,  
  id31,id32,id33,id34,id35,id36,id37,id38,id39,id40,
  id41,id42,id43,id44,id45,id46,id47,id48,id49,id50,
  id51,id52,id53,id54,id55,id56,id57,id58,id59,id60,
  id61,id62,id63,id64,id65,id66,id67,id68,id69,id70,
  id71,id72,id73,id74,id75,id76,id77,id78,id79,id80,
  id81,id82,id83,id84,id85,id86,id87,id88,id89,id90,
  id91,id92,id93,id94,id95,id96,id97,id98,id99,id100,
  id101,id102,id103,id104,id105,id106,id107,id108,id109,id110,
  id111,id112,id113,id114,id115,id116,id117,id118,id119,id120,
  id121,id122,id123,id124,id125,id126,id127,id128,id129,id130,
  id131,id132,id133,id134,id135,id136,id137,id138,id139,id140,
  id141,id142,id143,id144,id145,id146,id147,id148,id149,id150,
  id151,id152,id153,id154,id155,id156,id157,id158,id159,id160,
  id161,id162,id163,id164,id165,id166,id167,id168,id169,id170,
  id171,id172,id173,id174,id175,id176,id177,id178,id179,id180,
  id181,id182,id183,id184,id185,id186,id187,id188,id189,id190,
  id191,id192,id193,id194,id195,id196,id197,id198,id199,id200,
  id201,id202,id203,id204,id205,id206,id207,id208,id209,id210,
  id211,id212,id213,id214,id215,id216,id217,id218,id219,id220,
  id221,id222,id223,id224,id225,id226,id227,id228,id229,id230,
  id231,id232,id233,id234,id235,id236,id237,id238,id239,id240,
  id241,id242,id243,id244,id245,id246,id247,id248,id249,id250,
  id251,id252,id253,id254,id255,id256,id257,id258,id259,id260,
  id261,id262,id263,id264,id265,id266,id267,id268,id269,id270,
  id271,id272,id273,id274,id275,id276
};

char buf[18];

void setup(void) {
#if FAC != 1
  CPUSlowDown(FAC);
#endif
  buf[16] = 0x00;
// Serial.begin(115200); // change baudrate to 2400 on terminal when low CPU freq!
  lcd.begin(16, 2); 
  lcd.setCursor(0, 0);
  // メッセージを表示
  lcd.print("\xdb\xcb\xde \xc6\xdd\xbc\xb7\xba\xde \xcb\xae\xb3\xbc\xde");  //ﾛﾋﾞ ﾆﾝｼｷｺﾞ ﾋｮｳｼﾞﾞ
  delay(5000);  //ロビの起動を待たせる
}

uint8_t dt = 0;
//uint8_t dt1 = 0;
int id = 0;
int prev_id = 0;
bool display_line2 = false;

void loop(void)
{
  uint8_t i2c_adr = 80;
  uint8_t reg_adr = 33;
  char msg[32];

    if (i2c_start(i2c_adr|I2C_WRITE)) {              // スタートコンディションを発行する
          if (i2c_write(reg_adr)) {               // レジスタアドレスを指定
               if (i2c_rep_start(i2c_adr|I2C_READ)) { // リピート・スタートコンディションを発行する
                     dt = i2c_read(true);
                     id = (int) dt;
                     if (id <= 20)
                      {
                         i2c_stop() ;                                   // ストップコンディションを発行する
                          if (i2c_start(i2c_adr|I2C_WRITE)) {              // スタートコンディションを発行する
                                if (i2c_write(reg_adr - 1)) {               // レジスタアドレスを指定
                                     if (i2c_rep_start(i2c_adr|I2C_READ)) { // リピート・スタートコンディションを発行する
                                      dt = i2c_read(true);
                                         if (dt == 1)
                                          id += 256;
                                     }
                                }
                             }
                       } 
                     if (id != prev_id)
                     {
                                        
                       if (id == 0)
                          *msg = 0x00;
                        else if ((id >= 1) && (id <= 276))
                          strcpy_PF(msg, ninshiki[id-1]);                        
                       else
                           strcpy(msg,"???");
//                      Serial.println(msg);
                        if (display_line2)
                        {
                          lcd.setCursor(0, 1);
                          lcd.print("                ");
                        }
                        memset(buf, 0x20, 16);
                        if (strlen(msg) > 16)
                        {
                          lcd.setCursor(0, 1);
                          lcd.print(&msg[16]);
                          memcpy(buf, msg, 16);                        
                          display_line2 = true;
                        }
                        else
                        {
                           memcpy(buf, msg, strlen(msg));
                           display_line2 = false;
                       }
                        
                        lcd.setCursor(0, 0);
                        lcd.print(buf);
                        prev_id = id;
                  }
              }
          }
     }
     i2c_stop() ;                                   // ストップコンディションを発行する
     delay(500);
}
