// Scan I2C bus for device responses
/*
#define SDA_PORT PORTD
//#define SDA_PIN 3
#define SCL_PORT PORTD
#define SCL_PIN 5
*/
#define I2C_TIMEOUT 100
#define I2C_NOINTERRUPT 0
#define I2C_SLOWMODE 1
#define FAC 1
#define I2C_CPUFREQ (F_CPU/FAC)


// Corresponds to A4/A5 - the hardware I2C pins on Arduinos
#define SDA_PORT PORTC
#define SDA_PIN 4
#define SCL_PORT PORTC
#define SCL_PIN 5
#define I2C_FASTMODE 1

#include <SoftI2CMaster.h>
#include <avr/io.h>
#include <LiquidCrystal.h>


// 接続ピンをして指定してライブラリを初期化
//LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
LiquidCrystal lcd(5, 6, 7, 8, 9, 10, 11); //SD1602VBWB
//------------------------------------------------------------------------------
void CPUSlowDown(int fac) {
  // slow down processor by a fac
    CLKPR = _BV(CLKPCE);
    CLKPR = _BV(CLKPS1) | _BV(CLKPS0);
}
  
int count = 0;
uint8_t dt[7], dt0[7];
char buf[36];

void setup(void) {
#if FAC != 1
  CPUSlowDown(FAC);
#endif

//  Serial.begin(115200); // change baudrate to 2400 on terminal when low CPU freq!
  lcd.begin(16, 2); 
  lcd.setCursor(0, 0);
  lcd.print("Robi LCD");
  lcd.setCursor(0, 1);
  lcd.print("Message display");
  memset(buf, ' ', 32);
  buf[32] = 0x00;
  delay(5000);  //ロビの起動を待たせる
}


void loop(void)
{
  uint8_t i2c_adr = 8;
  uint8_t reg_adr = 2;

  for (reg_adr = 2; reg_adr <= 8; reg_adr++)
  {
    if (i2c_start(i2c_adr|I2C_WRITE)) {              // スタートコンディションを発行する
          if (i2c_write(reg_adr)) {               // レジスタアドレスを指定
               if (i2c_rep_start(i2c_adr|I2C_READ)) { // リピート・スタートコンディションを発行する
                     dt[reg_adr-2] = (char)i2c_read(true) ;
            }
          }
     }
    i2c_stop() ;                                   // ストップコンディションを発行する
  }

  count++;
  for (int i = 0; i < 7; i++)
  {
    if (dt[i] != dt0[i])
    {
      count = 0;
      break;
    }
  }
  if (count == 3) 
  {
    if ((dt[6] > 0) &&  (dt[6] < 32))
    {
      if (dt[6] == 1)
        memset(buf, ' ', 32);
     
      for (int i = 0; i < 6; i++)
      {
        buf[dt[6]+i-1] = dt[i];
      }

      lcd.setCursor(0, 0);
      lcd.print(buf);
      lcd.setCursor(0, 1);
      lcd.print(&buf[16]);
    }
  }
  memcpy(dt0, dt, 7);
  delay(100);
}
