// Scan I2C bus for device responses
/*
#define SDA_PORT PORTD
//#define SDA_PIN 3
#define SCL_PORT PORTD
#define SCL_PIN 5
*/
#define I2C_TIMEOUT 100
#define I2C_NOINTERRUPT 0
#define I2C_SLOWMODE 1
#define FAC 1
#define I2C_CPUFREQ (F_CPU/FAC)


// Corresponds to A4/A5 - the hardware I2C pins on Arduinos
#define SDA_PORT PORTC
#define SDA_PIN 4
#define SCL_PORT PORTC
#define SCL_PIN 5
#define I2C_FASTMODE 1

#include <SoftI2CMaster.h>
#include <avr/io.h>
#include <LiquidCrystal.h>


// 接続ピンをして指定してライブラリを初期化
//LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
LiquidCrystal lcd(5, 6, 7, 8, 9, 10, 11); //SD1602VBWB
//------------------------------------------------------------------------------
void CPUSlowDown(int fac) {
  // slow down processor by a fac
    CLKPR = _BV(CLKPCE);
    CLKPR = _BV(CLKPS1) | _BV(CLKPS0);
}
  


void setup(void) {
#if FAC != 1
  CPUSlowDown(FAC);
#endif

//  Serial.begin(115200); // change baudrate to 2400 on terminal when low CPU freq!
  lcd.begin(16, 2); 
  lcd.setCursor(0, 0);
  lcd.print("Robi Eye color");
  lcd.setCursor(0, 1);
  lcd.print("RGB display");
  delay(5000);  //ロビの起動を待たせる
}
int count = 0;
uint8_t dt[6], dt0[6];
char buf[18];

void loop(void)
{
  uint8_t i2c_adr = 8;
  uint8_t reg_adr = 2;

  for (reg_adr = 2; reg_adr <= 7; reg_adr++)
  {
    if (i2c_start(i2c_adr|I2C_WRITE)) {              // スタートコンディションを発行する
          if (i2c_write(reg_adr)) {               // レジスタアドレスを指定
               if (i2c_rep_start(i2c_adr|I2C_READ)) { // リピート・スタートコンディションを発行する
                     dt[reg_adr-2] = (char)i2c_read(true) ;
            }
          }
     }
    i2c_stop() ;                                   // ストップコンディションを発行する
  }
  count++;
  for (int i = 0; i < 6; i++)
  {
    if (dt[i] != dt0[i])
    {
      count = 0;
      break;
    }
  }
  if (count == 3)
  {
    sprintf(buf, "LEYE=%03d,%03d,%03d", dt[0], dt[1], dt[2]);
    lcd.setCursor(0, 0);
    lcd.print(buf);
    sprintf(buf, "REYE=%03d,%03d,%03d", dt[3], dt[4], dt[5]);
    lcd.setCursor(0, 1);
    lcd.print(buf);
  }
  memcpy(dt0, dt, 6);
  delay(100);
}
